''MCP3208_fast_multi_autosample test file

''Tests the three ADC chips and makes sure that they work.

'These are clock constants
  _xinfreq = 5_000_000                      
  _clkmode = xtal1 | pll16x

VAR

  long cycles, value[24]




OBJ


  debug : "FullDuplexSerialPlus"
  ADC   : "MCP3208_fast_multi_autosample"

PUB Main | counter, clock, previouscycles, displaycycles, chipA, chipB, chipC, chnA, chnB, chnC

  

      
  
  
  debug.start(31,30,0,57600)       ' Initialize comms from Prop to PC
  waitcnt(clkfreq*6 + cnt)
  debug.str(string("Starting ADC..."))
  waitcnt(clkfreq*3 + cnt)
   
  debug.str(string("Now"))         
  ADC.start(@cycles,20,19,21,23,22,24,26,25,27)
                                

  'Outputs data from three channels in a CSV format
  chipA := chipB := chipC := 1
  chnA := 3
  chnB := 4
  chnC := 5

  debug.dec(chipA)
  debug.str(string("-"))
  debug.dec(chnA)
  debug.str(string(","))
  debug.dec(chipB)
  debug.str(string("-"))
  debug.dec(chnB)
  debug.str(string(","))
  debug.dec(chipC)
  debug.str(string("-"))
  debug.dec(chnC)
  debug.tx(13)

  'precalculate the array indicies
  chipA := ((chipA-1)*8)+chnA
  chipB := ((chipB-1)*8)+chnB
  chipC := ((chipC-1)*8)+chnC
  
  repeat
    debug.dec(value[chipA])
    debug.tx(44)
    debug.dec(value[chipB])
    debug.tx(44)
    debug.dec(value[chipC])
    debug.tx(13)
    
  
  

  {
  'Tests all 24 channels and shows current value
  clock := cnt
  previouscycles := cycles
  repeat
    if cnt => clock + clkfreq
      clock += clkfreq
      displaycycles := cycles - previouscycles
      previouscycles := cycles
      
    debug.tx(1)                 'Home
    debug.str(string("ADC 24 Channel Test"))
    debug.tx(13)
    debug.str(string("Cycles per second: "))
    debug.tx(11)
    debug.dec(displaycycles)
    debug.tx(13)
    debug.str(string("Cycle: "))
    debug.tx(11)
    debug.dec(cycles)
    debug.tx(13)
    repeat counter from 0 to 23
      debug.str(string("Chip "))
      debug.dec((counter / 8)+1)
      debug.str(string(", Channel "))
      debug.dec(counter - (8*(counter / 8)))
      debug.str(string(" : "))
      debug.tx(11)
      debug.dec(value[counter])
      debug.tx(13)
   ' waitcnt(clkfreq/10 + cnt)
    }

                                     
    
    